unit MDIChld;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RTDesign, Menus;

type
  TMDIChild = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    FFileName : String;
  public
    Property FileName : String Read FFileName Write FFileName;
  end;

var
  MDIChild: TMDIChild;


implementation

{$R *.DFM}

uses MainUnit;

procedure TMDIChild.FormCreate(Sender: TObject);
begin
  FileName:='';
  RegisterClasses([TMainMenu, TMenuItem]);
end;

procedure TMDIChild.FormActivate(Sender: TObject);
begin
  MainForm.RTDesigner1.BaseControl:=Self;
end;

procedure TMDIChild.FormDestroy(Sender: TObject);
begin
  MainForm.RTDesigner1.BaseControl:=nil;
end;                    

procedure TMDIChild.FormPaint(Sender: TObject);
var x, y : Integer;
begin
  if not MainForm.RTDesigner1.EditMode Then Exit;
  y:=0;
  While y<=Height Do Begin
    x:=0;
    While x<=Width Do Begin
      Canvas.Pixels[x, y]:=clBtnText;
      inc(x, 8);
    End;
    inc(y, 8);
  End;
end;

end.
