unit MainUnit;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Buttons, ExtCtrls, StdCtrls, RTDesign;

type
  TMainForm = class(TForm)
    MainMenu2: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    ComponentBar: TPanel;
    BNone: TSpeedButton;
    BLabel: TSpeedButton;
    BShape: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Toolbar: TPanel;
    NewTB: TSpeedButton;
    OpenTB: TSpeedButton;
    SaveTB: TSpeedButton;
    Edit1: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    N4: TMenuItem;
    Undo1: TMenuItem;
    CutTB: TSpeedButton;
    CopyTB: TSpeedButton;
    PasteTB: TSpeedButton;
    N1: TMenuItem;
    Aligntogrid1: TMenuItem;
    Sendtoback1: TMenuItem;
    BringtoFront1: TMenuItem;
    BasePanel: TPanel;
    RTDesigner1: TRTDesigner;
    N3: TMenuItem;
    Editmode1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure RTDesigner1UndoChange(Sender: TObject);
    procedure RTDesigner1InsertQuery(Sender: TObject; Control: TControl;
      var aClass: TControlClass);
    procedure Aligntogrid1Click(Sender: TObject);
    procedure RTDesigner1PopulateDesignerMenu(Sender: TObject;
      var Menu: TPopupMenu);
    procedure Editmode1Click(Sender: TObject);
  private
    FileName : String;
  public
    Function GetControlClass : TControlClass;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

Function TMainForm.GetControlClass : TControlClass;
Begin
  Result:=nil;
  if BLabel.Down Then Result:=TLabel
  Else if BShape.Down Then Result:=TShape;
  BNone.Down:=True;
End;

procedure TMainForm.Open1Click(Sender: TObject);
begin
  if not OpenDialog.Execute Then Exit;
  RTDesigner1.ClearBaseControl;
  FileName:=OpenDialog.FileName;
  RTDesigner1.LoadBCFromFile(OpenDialog.FileName);
end;

procedure TMainForm.Save1Click(Sender: TObject);
var aFileName : String;
begin
  aFileName:=FileName;
  if (Sender=SaveAs1) or (aFileName='') Then Begin
    if not SaveDialog.Execute Then Exit;
    aFileName:=SaveDialog.FileName;
  End;
  RTDesigner1.SaveBCToFile(aFileName);
  FileName:=aFileName;
end;

procedure TMainForm.New1Click(Sender: TObject);
begin
  RTDesigner1.ClearBaseControl;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Undo1Click(Sender: TObject);
begin
  RTDesigner1.Undo;
end;

procedure TMainForm.Copy1Click(Sender: TObject);
begin
  RTDesigner1.CopyToClipboard;
end;

procedure TMainForm.Paste1Click(Sender: TObject);
begin
  RTDesigner1.PasteFromClipboard;
end;

procedure TMainForm.Cut1Click(Sender: TObject);
begin
  RTDesigner1.CopyToClipboard;
  RTDesigner1.DeleteSelection;
end;

procedure TMainForm.RTDesigner1UndoChange(Sender: TObject);
begin
  Undo1.Enabled:=RTDesigner1.UndoKind<>ukNone;
  Undo1.Caption:=RTDesigner1.UndoString;
end;

procedure TMainForm.RTDesigner1InsertQuery(Sender: TObject;
  Control: TControl; var aClass: TControlClass);
begin
  aClass:=GetControlClass;
end;

procedure TMainForm.Aligntogrid1Click(Sender: TObject);
begin
  RTDesigner1.AlignToGrid;
end;

procedure TMainForm.RTDesigner1PopulateDesignerMenu(Sender: TObject;
  var Menu: TPopupMenu);
begin
  Menu.Items.Add(NewLine);
  Menu.Items.Add(NewItem('This is only an example', 0, False, True, nil, 0, 'PopupMenuExample1'));
  Menu.Items.Add(NewItem('how to use OnPopulateDesignMenu', 0, False, True, nil, 0, 'PopupMenuExample2'));
end;

procedure TMainForm.Editmode1Click(Sender: TObject);
begin
  RTDesigner1.EditMode:=not RTDesigner1.EditMode;
end;

end.
